Bug 186247 - CVE-2006-1342 Small information leak in SO_ORIGINAL_DST and getname() (CVE-2006-1343)
Summary: CVE-2006-1342 Small information leak in SO_ORIGINAL_DST and getname() (CVE-20...
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 2.1
Classification: Red Hat
Component: kernel (Show other bugs)
(Show other bugs)
Version: 2.1
Hardware: ia64 Linux
medium
low
Target Milestone: ---
Assignee: Don Howard
QA Contact: Brian Brock
URL:
Whiteboard: impact=low,source=netdev,reported=200...
Keywords: Security
Depends On:
Blocks: 143573
TreeView+ depends on / blocked
 
Reported: 2006-03-22 14:55 UTC by Marcel Holtmann
Modified: 2007-11-30 22:06 UTC (History)
1 user (show)

Fixed In Version: RHSA-2006-0580
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-07-13 11:55:00 UTC
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)


External Trackers
Tracker ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2006:0580 normal SHIPPED_LIVE Moderate: kernel security update 2006-07-13 04:00:00 UTC

Description Marcel Holtmann 2006-03-22 14:55:00 UTC
It appears sockaddr_in.sin_zero is not zeroed during certain operations
returning IPv4 socket names, namely:

- getsockopt(...SO_ORIGINAL_DST...) (2.4 and 2.6)
  see getorigdst() in net/ipv4/netfilter/ip_conntrack_core.c
  (+ in net/ipv4/netfilter/nf_conntrack_l3proto_ipv4.c in 2.6?!)

- getsockname() and getpeername() (and accept()) (2.4 only)
  see inet_getname() in net/ipv4/af_inet.c

and several unitialized bytes of kernel stack (sizeof(sin_zero) == 6 to be
precise) leak to the userspace.

http://marc.theaimsgroup.com/?l=linux-netdev&m=114148078223594&w=2

A patch has been included in Marcelo's 2.4 tree:

http://www.kernel.org/git/?p=linux/kernel/git/marcelo/linux-2.4.git;a=commit;h=09d3b3dcfa80c9094f1748c1be064b9326c9ef2b

Comment 3 Mike Gahagan 2006-07-12 17:36:01 UTC
Fix looks ok (see bz186245)

.qa.[root@ia64-21as-bos root]# ./bug 12345
data: 02 00 84 7b ac 10 3b ce 00 00 00 00 00 00 00 00
data: 02 00 30 39 c0 a8 4c 93 00 00 00 00 00 00 00 00
getsockname(as): Protocol not available
.qa.[root@ia64-21as-bos root]# uname -a
Linux ia64-21as-bos.lab.boston.redhat.com 2.4.18-e.62smp #1 SMP Fri May 26
18:45:16 EDT 2006 ia64 unknown


Comment 5 Red Hat Bugzilla 2006-07-13 11:55:00 UTC
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.

http://rhn.redhat.com/errata/RHSA-2006-0580.html



Note You need to log in before you can comment on or make changes to this bug.